import type { ReadingLog } from "@utils/ReadingLog";
import { Command } from "./Command";
import moment from "@external/moment";

export class BackupReadingLogCommand extends Command {
	constructor(private readonly readingLog: ReadingLog) {
		super("create-reading-log-backup", "Create Reading Log Backup");
	}

	async callback() {
		const timestamp = moment().format("YYYY-MM-DD_HH-mm-ss");
		const backupFilename = `reading-log-backup_${timestamp}.json`;
		await this.readingLog.save(backupFilename);
	}
}
