export interface PreviousState<T> {
	get value(): T | undefined;
}

export function createPrevious<T>(getter: () => T): PreviousState<T> {
	let previous: T | undefined = $state();
	let current: T = $state(getter());

	$effect(() => {
		const newValue = getter();
		previous = current;
		current = newValue;
	});

	return {
		get value() {
			return previous;
		},
	};
}
